/**
 * Parse an expression.
 * @function parseExpression
 * @param {string} expression - Expression to parse.
 * @param {object} scope - Scope data.
 * @param {object} [options] - Optional settings.
 * @param {object} [options.pattern=/#{(.*?)}/g] - Expression pattern..
 */

'use strict'

let expressionError = require('../errors/expression_error')

/** @lends parseExpression */
function parseExpression (expression, context, options = {}) {
  let pattern = options.pattern || /[#\$]{(.*?)}/g
  return String(expression).replace(pattern, ($0, $1) => {
    try {
      return function () {
        let declares = 'let s = this,' + Object.keys(context || {})
            .map((key) => `${key}=s.${key}`)
            .join(', ')
        // noinspection Eslint
        return eval(`"use strict";${declares};${$1}`)
      }.call(context)
    } catch (e) {
      throw expressionError(expression, e)
    }
  })
}

module.exports = parseExpression
