/**
 * assert case for parseExpression.
 * Runs with mocha.
 */
'use strict'

const assert = require('assert')
const parseExpression = require('../lib/parsing/parse_expression.js')

describe('parse', () => {
  it('Parse expression', (done) => {
    let parsed = parseExpression('#{this.foo} and #{foo}', {
      foo: 'bar'
    })
    assert.equal(parsed, 'bar and bar')
    done()
  })

  it('Parse invalid expression', (done) => {
    assert.throws(function () {
      parseExpression('#{foo2} and #{foo3}', {
        foo: 'bar'
      })
    })
    done()
  })
})

/* global describe,it */
