/**
 * assert case for puddingEvaluator.
 * Runs with mocha.
 */
'use strict'

const assert = require('assert')
const PuddingEvaluator = require('../lib/pudding_evaluator.js')

describe('pudding', () => {
  it('Pudding evaluator', (done) => {
    let src = {
      foo: {
        bar: '#{1+2}',
        baz () {
          return 'bazz'
        },
        quz: '${i}'
      },
      hoge: 'This is #{hoge}'
    }
    let context = {
      i: 8,
      hoge: 'HOGEHOGE'
    }
    let evaluator = new PuddingEvaluator({})
    let data = evaluator.eval(src, context)
    console.log('data', data)
    assert.deepEqual(data, {
      foo: {
        quz: '8', baz: 'bazz', bar: '3'
      },
      hoge: 'This is HOGEHOGE'
    })
    done()
  })
})

/* global describe,it */


